SystemOrganization addCategory: #'Xpf-Multipoint-Plugin'!

SmartSyntaxInterpreterPlugin subclass: #MultiPointerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'mig 6/10/2009 13:48'!
hasHeaderFile

	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^ true! !

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'mig 6/10/2009 13:48'!
requiresPlatformFiles

	"this plugin requires platform specific files in order to work"
	^ true! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'mig 6/10/2009 13:47'!
initialiseModule

	self export: true.
	^ self cCode: 'multiPointerInit()' inSmalltalk: [true]! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'mig 6/10/2009 13:47'!
moduleUnloaded: aModuleName 

	self export: true.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 13:26'!
primitiveMultiPointerBufferSemaphoreHandle: aSemaIndex

	self primitive: 'multiPointerSetBufferSemaphoreHandle' parameters: #(SmallInteger).
	
	self multiPointerSetBufferSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 13:26'!
primitiveMultiPointerDeviceCount

	self primitive: 'primitiveMultiPointerDeviceCount'.
	
	^ self multiPointerDeviceCount asSmallIntegerObj! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 13:59'!
primitiveMultiPointerGetNextEvent
	"Primitive. Return the next input event from the VM event queue."
	| evtBuf arg value |
	self var: #evtBuf declareC:'int evtBuf[8] = { 0, 0, 0, 0, 0, 0, 0, 0 }'.
	self cCode:'' inSmalltalk:[evtBuf := CArrayAccessor on: (IntegerArray new: 8)].
	arg := self stackTop.
	((self isArray: arg) and:[(self slotSizeOf: arg) = 8])  ifFalse:[^self primitiveFail].

	self multiPointerGetNextEvent: evtBuf.
	"successFlag ifFalse:[^nil]."

	"Event type"
	"self storeInteger: 0 ofObject: arg withValue: (evtBuf at: 0)."
	"successFlag ifFalse:[^nil]."

	"Event time stamp"
	"self storeInteger: 1 ofObject: arg withValue: ((evtBuf at: 1) bitAnd: MillisecondClockMask)."
	"successFlag ifFalse:[^nil]."

	"Event arguments"
	0 to: 7 do:[:i|
		value := evtBuf at: i.
		(self isIntegerValue: value)
			ifTrue:[self storeInteger: i ofObject: arg withValue: value]
			ifFalse:["Need to remap because allocation may cause GC"
				self pushRemappableOop: arg.
				value := self positive32BitIntegerFor: value.
				arg := self popRemappableOop.
				self storePointer: i ofObject: arg withValue: value]].

	"successFlag ifFalse:[^nil]."
	self pop: 1.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 6/11/2009 18:14'!
primitiveMultiPointerLively: aPointerID

	self primitive: 'primitiveMultiPointerLively'.
	
	^ (self multiPointerLively: (aPointerID asCUnsigned)) asSmallIntegerObj! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 13:28'!
primitiveMultiPointerUseOSInput

	self primitive: 'primitiveMultiPointerUseOSInput'.
	
	self multiPointerUseOSInput.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 8/13/2009 13:28'!
primitiveMultiPointerUseSoftwareMouse

	self primitive: 'primitiveMultiPointerUseMultiInput'.
	
	self multiPointerUseMultiInput.! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'mig 6/10/2009 13:47'!
shutdownModule

	self export: true.
	^ self cCode: 'multiPointerShutdown()' inSmalltalk: [true]! !
